#include "agltools.h"

int agldimen = 0;
int aglsize  = 0;

void initagldim( int d )
{
agldimen = d;
aglsize  = 1 << d;
}

agl getagl(  shortvec u )
{
agl res;
res  = calloc( agldimen + 1 , sizeof( shortvec) );
res[ agldimen ] = u; 
return res;
}



ullong glcard( int  m )
{ ullong res = 1;
  int i;
  for( i = 0; i < m; i++ )
          res *=  ( 1LU << m )  - ( 1LU <<  i );
  return res;
}

ullong aglcard( int  m )
{ ullong res = 1;
  int i;
  for( i = 0; i < m; i++ )
          res *=  ( 1LU << m )  - ( 1LU <<  i );
  return res << m;
}

int agldet( agl a)
{
    shortvec *aux;
    int bit, i, j, vec, m;
    m = agldimen;
    aux = (shortvec *) malloc(sizeof(short) * (m + 1));
    for (i = 0; i < m; i++)
        aux[i] = a[i];
    aux[m] = (1 << m) - 1;
    bit = 1;
    for (i = 0; i < m; i++) {
        j = i;
        while ((bit & aux[j]) == 0)
            j++;
        if (j == m) {
            free(aux);
            return (0);
        }
        vec = aux[i];
        aux[i] = aux[j];
        aux[j] = vec;
        for (j = i + 1; j < m; j++)
            if ((bit & aux[j]) > 0)
                aux[j] = aux[j] ^ aux[i];
        bit = bit << 1;
    }
    free(aux);
    return (1);
}


agl getaglrand(  shortvec u )
{
int i;
int mask = (1 << agldimen) - 1;
agl res;
res = calloc( agldimen + 1, sizeof( shortvec) );
do {
    for( i = 0; i < agldimen; i++ )
	res[i] = random() & mask;
} while ( ! agldet(res) );
res[ agldimen ]  = u;
return res;
}


void setaglidt(  agl res, shortvec u )
{
int i;
for( i = 0; i < agldimen; i++ )
	res[i] = 1 << i;
res[ agldimen ] = u;
}

agl getaglidt(  shortvec u )
{
int i;
agl res;
res = calloc( agldimen + 1, sizeof( shortvec) );
for( i = 0; i < agldimen; i++ )
	res[i] = 1 << i;
res[ agldimen ]  = u;
return res;
}

int  isaglidt(  agl res )
{
int i;
for( i = 0; i < agldimen; i++ )
	if ( res[i] !=  (1 << i) ) return 0;;
return ( res[ agldimen ]  == 0 );
}



agl agltranspose(agl s)
{
    agl b = getagl( 0 );
    int i, j;
    for (i = 0; i < agldimen; i++)
	for (j = 0; j < agldimen ; j++)
	    if ((s[j] & (1 << i)) != 0)
		b[i] |=  (1 << j);
    return b;
}


int aglcmp( agl A, agl B )
{
int i;
for( i=0; i <=agldimen && A[i] == B[i]; i++ ) ; // yes
if ( i > agldimen ) return 0;
if ( A[i] < B[i] ) return -1;
return +1;
}
 
agl opS( void )
{ agl s;
  int i;
  s = getagl( 0 );
  for( i = 1; i < agldimen; i++ )
    s[i] = 1 << (i-1);
  s[0]  =  1 << (agldimen-1); 
  return s;
}

agl opT( void )
{ agl s;
  s = getaglidt( 0 );
  s[0]  ^= 2; 
  return s;
}

agl opU( void )
{ agl s;
  s = getaglidt( 1 );
  return s;
}


void    aglfreeGroup (aglGroup g)
{ 
 aglGroup aux;
 while ( g ) {
    aux = g;
    g   = aux->next;
    free(aux->per);
    free(aux);
 }
} 

aglGroup aglnewgrp( void )
{ aglGroup res;
  res = (aglGroup) malloc( sizeof(enraglGroup)) ;
  res -> next = NULL;
  return res;
}


agl getaglcpy( agl A )
{
int i;
agl r = getagl(0);
for(i=0; i <= agldimen; i++ )
	r[i] = A[i];
return r;
}


void addgen( agl p, aglGroup *G )
{ aglGroup r;
  r = aglnewgrp( );
  r->per  = p ;  
  r->next = *G;
  *G = r;
} 

void addgencpy( agl p, aglGroup *G )
{ aglGroup r;
  r = aglnewgrp( );
  r->per  = getaglcpy( p ) ;  
  r->next = *G;
  *G = r;
} 

aglGroup aglGroupcpy( aglGroup ldg)
{
 aglGroup aux, r=NULL;
  while ( ldg ) {
  	aux = aglnewgrp( );
  	aux->per  = getaglcpy( ldg->per );
  	aux->next = r;
        r  = aux;
	ldg = ldg->next;
  }
  return r;
}

aglGroup aglGroupConjugue( agl left, aglGroup ldg, agl right)
{
 aglGroup aux, r=NULL;
 agl tmp;
  while ( ldg ) {
  	aux = aglnewgrp( );
	tmp = getaglCompose( left, ldg->per);
  	aux->per  = getaglCompose( tmp, right);
	free( tmp );
  	aux->next = r;
        r  = aux;
	ldg = ldg->next;
  }
  return r;
}
aglGroup  mkaglGroup( void )
{ aglGroup r = NULL;
  agl s, t, u;
  s = opS(  ); 
  t = opT(  );
  u = opU(  );
  addgen( s , &r);
  addgen( t , &r); 
  addgen( u , &r);
  return r;
}

aglGroup  mkglGroup( void )
{ aglGroup r = NULL;
  agl s, t;
  s = opS(  ); 
  t = opT(  );
  //u = opU( m );
  addgen( s , &r);
  addgen( t , &r); 
  return r;
}


shortvec aglImage( shortvec x, agl s )
{ int i;
  shortvec r = 0;
  for( i = 0; i < agldimen; i++ )
    if ( (1<<i) & x ) 
      r ^= s[ i ];
  return r ^ s[ agldimen ];
}

void msgagl( FILE*dst, char *msg, agl s)
{ int i, j;
  printf("%s", msg);
  for( i = 0; i < agldimen; i++ ){
    if ( i == 0 ) fprintf(dst, "["); else fprintf(dst, " ");
    for( j = 0; j < agldimen; j++ )
      fprintf(dst, "%d", ( (1 << j) & s[i] ) > 0 );
  }  
  fprintf(dst, "]");
  for( j = 0; j < agldimen; j++ )
    fprintf(dst, "%d", ( (1 << j) & s[agldimen] ) > 0 );
}

void pshortvec( FILE *dst, shortvec v )
{
int j;
fprintf(dst, "\n(");
for( j = 0; j < agldimen; j++ )
      fprintf(dst, "%d", ( (1 << j) & v ) > 0 );
fprintf(dst, ")");
}

void pagl( FILE*dst, agl s)
{ int i, j;
  
  for( i = 0; i < agldimen; i++ ){
    if ( i == 0 ) fprintf(dst, "\n["); else fprintf(dst, " ");
    for( j = 0; j < agldimen; j++ )
      fprintf(dst, "%d", ( (1 << j) & s[i] ) > 0 );
  }  
  fprintf(dst, "]");
  for( j = 0; j < agldimen; j++ )
    fprintf(dst, "%d", ( (1 << j) & s[agldimen] ) > 0 );
}

void paglmsg( FILE*dst, char* msg, agl s)
{
fprintf( dst, "%s", msg  );
pagl( dst, s );
}
void paglGroup( FILE*dst, aglGroup g)
{ aglGroup aux;
  int     n = 0;
  aux = g;
  while ( aux ) {
    pagl(dst,aux->per);
    aux = aux->next;
    n++;
  }  
}

agl strtoagl( char bfr[] )
{ char *ptr;
  agl  s = getagl(0);
  int i, j;
  shortvec x;
  ptr = &(bfr[0]);
  for( i = 0; i <= agldimen; i++ ){
     ptr++;
     x = 0;
     for( j = 0; j < agldimen; j++ ){
       x |= (*ptr - '0') << j;//
       ptr++;
     }
     if ( i < agldimen ) s[i] = x;
     else s[agldimen] = x;
  } 
  return s;
}
void addgenstr( char bfr[], aglGroup *g)
{ char *ptr;
  agl  s = getagl(0);
  int i, j;
  shortvec x;
  ptr = &(bfr[0]);
  for( i = 0; i <= agldimen; i++ ){
     ptr++;
     x = 0;
     for( j = 0; j < agldimen; j++ ){
       x |= (*ptr - '0') << j;//
       ptr++;
     }
     if ( i < agldimen ) s[i] = x;
     else s[agldimen] = x;
  } 
  addgen( s, g);
}

void agladd( agl res, agl s)
{ int i;
  for( i = 0; i <= agldimen; i++ )
	res[i] ^= s[i];
}



void aglComposefragile( const agl s, agl t)
{ shortvec r = 0;
  int i, j;
  for( i = 0; i < agldimen; i++ ){
    r = 0;
    for( j = 0; j < agldimen; j++ )
       if ( (1<<j) & t[i] )
         r ^= s[ j ];
    t[i] = r;
  }
  t[agldimen] = aglImage( t[agldimen], s);
}

agl aglComposebyinverse( agl t, agl s)  // t' o s
{ agl  tmp = aglinverse(t);
  agl  res = getaglCompose(  tmp, s );
  free(tmp);
  return res;
}

void aglsquare( agl s )
{ agl tmp = getaglcpy( s );
  aglComposefragile( tmp, s );
  free( tmp );
}

// return the composition s o t
agl getaglCompose( agl s, agl t)
{ agl res = getagl(0);
  shortvec r = 0;
  int i, j;
  for( i = 0; i < agldimen; i++ ){
    r = 0;
    for( j = 0; j < agldimen; j++ )
       if ( (1<<j) & t[i] )
         r ^= s[ j ];
    res[i] = r;
  }
  res[agldimen] = aglImage( t[agldimen], s);
  return res;
}

agl aglpower( agl x, int n )
{
agl res = getaglidt(0);
agl s = getaglcpy(x);
while ( n ) {
   if ( n % 2 ) 
	aglComposefragile(s , res );
   aglsquare( s );
   n /= 2;
}
free(s);
return res;
}
int isaglidentity( agl x )
{
int i;
for( i=0; i < agldimen; i++ )
   if ( (1 << i) != x[i] ) return 0;
return  x[agldimen] == 0;
}


// something to do here !
int aglorder( agl s )
{
int r = 0;
agl x = getaglidt(0), tmp;
do {
   tmp = getaglCompose( x, s ); 
   free( x );
   x = tmp;
   r++;
} while ( ! isaglidentity( x ) );
free( x );
return r;
}

agl aglinverse( agl s )
{ agl res = getagl( 0 );
  int i,j, bit, tmp;
  shortvec r[ agldimen ], b[agldimen];
  for( i = 0; i < agldimen; i++){
     r[i] = 1 << i;
     b[i] = s[i];
  }
  bit = 1;
  for( i = 0; i < agldimen; i++, bit <<= 1 ) {
             j = i;
             while ( 0 == ( b[j] & bit) ) j++;
             tmp = b[i]; b[i] = b[j]; b[j] = tmp;
             tmp = r[i]; r[i] = r[j]; r[j] = tmp;
             for( j = i + 1;  j < agldimen; j++)
                  if (  b[j] &  bit )
                    { b[j] ^= b[i]; r[j]^=r[i];}
             }
        bit =  1 << ( agldimen - 1);
        for( i = agldimen-1; i >=0  ; i--, bit >>= 1 ) {
             for( j = i - 1;  j >=0 ; j--)
                  if (  b[j] &  bit )
                     { b[j] ^= b[i]; r[j]^=r[i];}
             }
 for( i = 0; i < agldimen; i++)
   res[i] = r[i];
 res[agldimen] = 0;
 res[agldimen] = aglImage(s[agldimen], res);
 return (res);
}      

// something todo here !
agl aglConjugate( agl A, agl g )
{
        agl l = aglinverse(g) ;
        agl t = getaglCompose(l, A );
        agl r = getaglCompose( t, g );
        free( l );
        free( t );
        return r;
}

agl aglComposeInverse( agl A, agl g )
{
        agl l = aglinverse(g) ;
        agl r = getaglCompose( A, l );
        free( l );
        return r;
}


