#ifndef BASISTOOLS_H
#define BASISTOOLS_H
#include "agltools.h"
#include "boolean.h"
#include "code.h"

#include <stdint.h>


typedef uint64_t  vector;

typedef struct {
	int s, t, m, q;
	code mat;
	vector *dirac;
	uchar  *table;
	int    rank;
	size_t orbSize;
	size_t size;
} basis_t;


void freeBasis( basis_t b );
basis_t monomialBasis( int s, int t, int m );

void rsreduction( boole f, int s, int t, int q);
void saveBase( basis_t b);
void loadBase( basis_t * b );
void saveBasename( char *name, basis_t b);
void loadBasename( char *name, basis_t * b );
void infoBase( basis_t * b , int verb );
int  checkBasename( char* name, basis_t * b );
#endif
