#ifndef CODE_H
#define CODE_H

#include "boolean.h"
#include <assert.h>
#include <stdint.h>

typedef struct {
  boole* fct;
  int*   piv;
  int    nbl, nbc;
} code;

void codeImage( uchar Y[], uchar X[], code G );
void pline( char*msg, uchar L[], int n );

int imageAffineLineaire( uchar X[], code G , int affine);
void pCode( char*msg, code G, code H );
code getcode( int k , int n);
code rmcode( int s, int t,  int m );
int  rmdimen( int s, int t, int m);
code solve(  uchar X[], code G , uchar Y[], int *solvable);
void  pcode( char*msg, code G  );
int  pivotage( code G  );
int fullpivotage( code G );
void  randPivotage( code G  );
code copyCode( code G );
code  kernel( code B, code G  );
code multicode( code cc, boole f );
int  reduce( boole v, code G );
void quotient( code G, code R );
code loadcode( char *fn );
void freecode( code c );
/*
code rmtranslate( int r, int s, boole f  );
code catcode( code A, code B );
void pcode( code G );
void picode( code G, int pi[], int n );
int rankcode( code G );
int * normalize( code G );
code orthogonal( code G );
void freecode( code G );
code randcode( int d );
code loadcode( char *fn );
code rmcodevar( int s, int t, int m);
*/

#endif
