#include "distrib.h"

int nouvelle = 0;

static int discompare( const void *a,  const void *b)
{
    dis_t* fa, *fb;
  int i;
  fa = (dis_t*) a;
  fb = (dis_t*) b;
  int  L;
  if ( fa->dis[0] != fb->dis[0] )
       return ( fa->dis[0] - fb->dis[0] );

  L = fa->dis[0];
  for ( i = 1; i <= L ; i++)
        if ( fa ->dis[i] != fb ->dis[i])
            return fa->dis[i] - fb->dis[i];

  return 0;
}


void glue( int *tfr, int* t, int q  )
{
int j, min, max;
min = max = tfr[0];
for( j  = 0;  j < q ; j++ ){
        if ( tfr[j] > max ) max = tfr[j];
        if ( tfr[j] < min ) min =  tfr[j];
}
for( j  = 0;  j < q ; j++ )
	tfr[j] = t[j]* (max-min+1)  + tfr[j] - min; 

}


int * compress( int* tfr, int q , int mode )
{
int j, qte, v;
int max, min, plage;
int *res = calloc( q, sizeof(int) );
int * mult;
if ( mode ) 
	Fourier( tfr, q);
min = max = tfr[0];
for( j  = 0;  j < q ; j++ ){
	if ( tfr[j] > max ) max = tfr[j];
	if ( tfr[j] < min ) min =  tfr[j];
}

plage = max - min + 1 ;
mult = calloc( plage  , sizeof(int) );
for( j  = 0;  j < q ; j++ )
	mult[  tfr[j] - min  ]++;
j   = 1;
qte = 0;
v   = 0;
while ( qte  < q && v < plage ) {
        if ( mult[ v ] ) {
                res[ j ] = v * q  +  mult[v] ;
                qte += mult[v];
                j++;
        }
        v++;
}
res[0] = j-1;
free( mult );
return res;
}

dis_t * getDistribution( int *t, int q, int mode )
{ dis_t *res = malloc( sizeof(dis_t) );
  res->dis = compress( t, q, mode );
  res->val = -1;
  //L = res->dis[0];
  // printf("\ndis %d:", L);
  //for ( i = 1; i < L ; i++)
  //	printf(" %3d [%d]", res->dis[i] %q,   res->dis[i] / q  );

  return res;
}

dis_t * getsmpDistribution( int *t, int q  )
{ dis_t *res = malloc( sizeof(dis_t) );
  res->dis = calloc( q + 1 , sizeof(int) );
  int i;
  for( i=0; i < q; i++ )
	  res->dis[i+1] = t[i];
  res->dis[0] = q;
  res->val = -1;
  //L = res->dis[0];
  // printf("\ndis %d:", L);
  //for ( i = 1; i < L ; i++)
  //	printf(" %3d [%d]", res->dis[i] %q,   res->dis[i] / q  );

  return res;
}


int findtable( int *t, int q,  void **rootp, int* count, int mode   )
{
dis_t *ptr;
const void *ret;
int value;
ptr = getDistribution(  t , q , mode );
//free( t );
    ret  = tsearch((void *) ptr, rootp , discompare );
    if ( ret == NULL)
        exit(EXIT_FAILURE);
    if ((*(dis_t **) ret)->dis != ptr->dis ) {
        value = (*(dis_t**) ret)->val;
        free( ptr->dis );
        free( ptr );
    	//printf("old value -> %d \n", value );
	nouvelle = 0;
        return value;
    };
    // it's new ! 
    nouvelle  = 1;
    ptr->val = *count;
    *count   = *count + 1;
    value = ptr->val;
    //printf("\nnew distribution  -> %d \n", value );
    return value;
}

int findspltable( int *t, int q,  void **rootp, int* count )
{
dis_t *ptr;
const void *ret;
int value;
ptr = getsmpDistribution(  t , q  );
//free( t );
    ret  = tsearch((void *) ptr, rootp , discompare );
    if ( ret == NULL)
        exit(EXIT_FAILURE);
    if ((*(dis_t **) ret)->dis != ptr->dis ) {
        value = (*(dis_t**) ret)->val;
        free( ptr->dis );
        free( ptr );
        nouvelle = 0;
        return value;
    };
    // it's new ! 
    ptr->val = *count;
    *count   = *count + 1;
    value = ptr->val;
    nouvelle = 1;
    return value;
}


