#include "distribccz.h"

int   count[ NBITEM ] = {0};
void* rootp[ NBITEM ] = {NULL};


static int discompare( const void *a,  const void *b)
{
    dis_t* fa, *fb;
  int i;
  fa = (dis_t*) a;
  fb = (dis_t*) b;
  int  L;
  if ( fa->dis[0] != fb->dis[0] )
       return ( fa->dis[0] - fb->dis[0] );

  L = fa->dis[0];
  for ( i = 1; i < L ; i++)
        if ( fa ->dis[i] != fb ->dis[i])
            return fa->dis[i] - fb->dis[i];

  return 0;
}



int * compress( int* tfr, int q  )
{
int j, qte, v;
int max, min, plage;
int *res = calloc( q, sizeof(int) );
int * mult;
min = max = tfr[0];
for( j  = 0;  j < q ; j++ ){
	if ( tfr[j] > max ) max = tfr[j];
	if ( tfr[j] < min ) min =  tfr[j];
}

plage = max - min + 1 ;
mult = calloc( plage  , sizeof(int) );
for( j  = 0;  j < q ; j++ )
	mult[  tfr[j] - min  ]++;
j   = 1;
qte = 0;
v   = 0;
while ( qte  < q && v < plage ) {
        if ( mult[ v ] ) {
                res[ j ] = v * q  +  mult[v] ;
                qte += mult[v];
                j++;
        }
        v++;
}
res[0] = j;
free( mult );
res = realloc(res , (j + 1) * sizeof(int) );
return res;
}

static dis_t * getDistribution( int *t, int q )
{ dis_t *res = malloc( sizeof(dis_t) );
  res->dis = compress( t, q );
  res->num = -1;
  //L = res->dis[0];
  // printf("\ndis %d:", L);
  //for ( i = 1; i < L ; i++)
  //	printf(" %3d [%d]", res->dis[i] %q,   res->dis[i] / q  );

  return res;
}


int cczfindtable( int *t, int q,  int i )
{
dis_t *ptr;
const void *ret;
int value;
ptr = getDistribution(  t , q );
//free( t );
    ret  = tsearch((void *) ptr, & rootp[i] , discompare );
    if ( ret == NULL)
        exit(EXIT_FAILURE);
    if ((*(dis_t **) ret)->dis != ptr->dis ) {
        value = (*(dis_t**) ret)->num;
        free( ptr->dis );
        free( ptr );
    	//printf("old value -> %d \n", value );
        return value;
    };
    // it's new ! 
    ptr->num  = count[i];
    count[i]++;
    value = ptr->num;
    //printf("\nnew distribution  -> %d \n", value );
    return value;
}



