
#include "formtools.h"

int formDimen;
int64_t formSize;
int *monomial;
int *number;
int formDegree;


static int binomial(int r, int m)
{
//we do not need more !
    if (r == 0 || r == m)
	return 1;
    return binomial(r, m - 1) + binomial(r - 1, m - 1);
}

void initForm(int r, int m)
{
    int j = 0;
    shortvec u;
    formDimen = binomial(r, m);
    formSize = 1LU << formDimen;
    formDegree = r;
    monomial = calloc(formDimen, sizeof(int));
    number = calloc(ffsize, sizeof(int));
    for (u = 0; u < ffsize; u++) {
	number[u] = -1;
	if (weight(u) == formDegree) {
	    monomial[j] = u;
	    number[u] = j;
	    j++;
	}


    }

}

void closeForm(void)
{
    free(number);
    free(monomial);
}

form booletoform(boole f)
{				// return a form from f and transform f to ANF
    form res = 0;
    shortvec u;
    TTtoANF(f);
    for (u = 0; u < ffsize; u++) {
	if (f[u] && (number[u] >= 0)) {
	    res ^= 1LU << number[u];
	}
    }
    //phil : l'os etait ici !!!
    TTtoANF(f);
    return res;


}


aglForm getaglForm(void)
{
    return calloc(formDimen + 1, sizeof(form));
}

aglForm action(boole f, agl s)
{
    int j;
    shortvec x, u;
    aglForm res = getaglForm();
    boole g = getboole();
    boole h = getboole();

    for (x = 0; x < ffsize; x++) {
	g[x] = f[aglImage(x, s)] ^ f[x];

    }
    res[formDimen] = booletoform(g);	// g is ANF after booletoform
    for (j = 0; j < formDimen; j++) {
	for (u = 0; u < ffsize; u++) {
	    g[u] = 0;
	}
	g[monomial[j]] = 1;
	ANFtoTT(g);
	for (x = 0; x < ffsize; x++) {
	    h[x] = g[aglImage(x, s)];
	}
	res[j] = booletoform(h);
    }
    free(g);
    free(h);
    return res;
}

void  aglFormGroupFree( aglFormGroup l)
{ 
	aglFormGroup aux;
	while ( l ) {
		aux = l;
		l = l->next;
		free( aux->act);
		free( aux );
	}
}

aglFormGroup aglGroupAction(class K)
{
// builds the generators for the action of
// the class K on the form space
    aglFormGroup res = NULL;

    aglGroup aux;
 

    aglFormGroup tmp;

    aux = K->stab;
    while (aux != NULL) {
	tmp = malloc(sizeof(enraglFormGroup)) ;	               
	tmp->per = aux->per;		// partage de l'espace memoire
	tmp->act = action(K->fct, aux->per);		
	tmp->next = res;
	res = tmp;
	aux = aux->next;
    }
    return res;

}

// return the sum of the Boolean function fct and the form w.
boole getbooleFormsum( boole fct, form w )
{ boole res = getboole();
  shortvec u, j;
  for( j = 0; j < formDimen; j++ )
	  if (  BITFORM(j,w) ) 
		  res[ monomial[j]  ] =  1;
  ANFtoTT( res );
  for( u = 0; u < ffsize; u++ )
	 res[u] ^= fct[u];
  return res; 
}

form aglFormImage( form f, aglForm S){
// the image of f by the action S
form  r=0;
int j;
for( j = 0; j < formDimen; j++ )
	  if (  BITFORM(j,f) )
	  		r^= S[j];
// A bug was here...
r^= S[ formDimen ];
return r;

}






