#include "distribccz.h"
#include "invariantccz.h"

int nbitem = 3;
int  invcount  = 0;
void *invrootp = NULL;


inv_t *getInvariantccz( int K[]  )
{ inv_t *res = malloc( sizeof(inv_t) );
  int i;
  for( i = 0; i < nbitem; i++ )
  	res->item[i] = K[i];
  res->val  = -1;
  return res;
}

static int compare( const void *a,  const void *b)
{
    inv_t* fa, *fb;
    int i;
  fa = (inv_t*) a;
  fb = (inv_t*) b;
    
   for ( i = 0; i < nbitem; i++ ) 
	   if ( fa->item[i]  !=  fb->item[i] )
	       return fa->item[i]  - fb->item[i];
    return 0;
}

int newInvariantccz( int K[] )
{
inv_t *ptr;
const void *ret;
ptr = getInvariantccz(  K );

    ret  = tsearch((void *) ptr, &invrootp , compare );
    if ( ret == NULL)
        exit(EXIT_FAILURE);
    if ((*(inv_t **) ret)->val != ptr->val) {
        free( ptr );
        return 0;
    };
// it's new ! 
    ptr->val = invcount;
    invcount    = invcount + 1;
    printf("\nnew invariant value -> %d \n", ptr->val );
    return 1;
}

int InvariantValueccz( int K[] )
{
inv_t *ptr;
const void *ret;
ptr = getInvariantccz(  K );

    ret  = tsearch((void *) ptr, &invrootp , compare );
    if ( ret == NULL)
        exit(EXIT_FAILURE);
    if ((*(inv_t **) ret)->val != ptr->val) {
        free( ptr );
        return (*(inv_t **) ret)->val;
    };
// it's new ! 
    ptr->val = invcount;
    invcount   = invcount + 1;
    return ptr->val ;
}



