#include <stdlib.h>
#include "boolean.h"
#include "ctype.h"
#include "mapping.h"

mapping getmap( void ) {
return ( mapping ) calloc ( ffsize, sizeof(uchar) );
}

mapping strtomap(  char *bfr )
{ char *ptr;
  mapping res;
  galois x = 0, y;
  res = getmap();
  ptr = bfr;
  while ( *ptr != '=' ) ptr++;
  ptr++;
  while ( *ptr ) {
    if ( isdigit( *ptr ) ){
      y = 0;
      while ( isdigit( *ptr ) ) {
         y  *= 10;
         y  += *ptr - '0';
         ptr++;
     }
     res[x++] = y;
    } else ptr++;
  }
  if ( x != ffsize ) {
	fprintf(stderr,"str=%s x=%d", bfr, x);
        exit(1);
  }
  return res;
}


int isapn( mapping fct )
{
    int x, a, y;
    int cpt[ffsize];
    for (a = 1; a < ffsize; a++) {
	for (x = 0; x < ffsize; x++)
	    cpt[x] = 0;
	for (x = 0; x < ffsize; x++) {
	    y = fct[x ^ a] ^ fct[x];
	    cpt[y]++;
	    if (cpt[y] > 2)
		return 0;
	}
    }
    return 1;
}

void coordinate( mapping b, mapping f, int i)
{
galois x;
for( x = 0; x < ffsize; x++)
    b[x] = ( f[x] & (1<<i) ) > 0;
}

boole component( galois  v, mapping F )
{
	boole res =  getboole();

galois x;
for( x = 0; x < ffsize; x++)
    res[x]  = weight( ( F[x]  & v) ) & 1;
return res;
}

void xprintmap( FILE *dst, char *msg, mapping f)
{
int i;
mapping h = getmap();
fprintf(dst, "%s", msg);
for( i = 0; i < ffdimen; i++){
     coordinate(h, f, i );
     fprintf( dst, "\n#%d:", i+1);
     panf(dst, h );
     }
free(h);
}

int mapdegree( mapping f )
{
int i, r=-1, d;
mapping h = getmap();
for( i = 0; i < ffdimen; i++){
     coordinate(h, f, i );
     d = degree( h );
     if ( d > r ) r = d;
     }
free(h);
return r;
}


mapping  loadmapvalue(FILE *src, int *value )
{
  char line[1024];
  while (! feof (src) )
    {
      line[0] = '\0';
      fgets (line, 1024, src);
      switch (*line)
	{
	case '#':
	  break;
	case 'T' :
	  assert( 1 == sscanf( line, "TT %d", value ) );
	  return strtomap ( line );
	  break;
	default:;
	}
    }
    return NULL;
}
mapping  loadmap(FILE *src )
{
  char line[1024];
  while (! feof (src) )
    {
      line[0] = '\0';
      fgets (line, 1024, src);
      switch (*line)
	{
	case '#':
	  break;
	case 'T' :
	  return strtomap ( line );
	  break;
	default:;
	}
    }
    return NULL;
}

mapping  loadaglmapsize(FILE *src, aglGroup *g, uint64_t *size)
//-get the current object function
{
  mapping  f;
  char line[1024];
  *g = NULL;
  while (! feof (src) )
    {
      line[0] = '\0';
      fgets (line, 1024, src);
      switch (*line)
        {
        case '#':
          break;
        case '[' :
          addgenstr( line, g);
          break;
	case 'T' : case 't' :
          f = strtomap ( line );
          break;
        case 's' :
          sscanf( line, "stabSize=%ld", size );
          return f;
          break;
        default:;
        }
    }
    return NULL;
}





mapping  loadparmsmap(FILE *src , int* val, int *rep )
{
  char line[1024];
  mapping map;
  while (! feof (src) )
    {
      line[0] = '\0';
      fgets (line, 1024, src);
      switch (*line)
	{
	case '#':
	  break;
	case 'v':
	  sscanf( line,  "val=%d", val );
	  break;
	case 'r':
	  sscanf( line,  "rep=%d", rep );
	  return map;
	  break;
	case 'T' :
	  map = strtomap ( line );
	  break;
	default:;
	}
    }
    return NULL;
}

void fprintmap( FILE*dst, mapping f )
{
galois x;
fprintf(dst, "\nfct=");
for( x = 0; x < ffsize; x++ )
  fprintf(dst, " %d", f[x] );
}

void fprintmapvalue( FILE*dst, int j, mapping f )
{
galois x;
fprintf(dst, "\ntt %d =", j);
for( x = 0; x < ffsize; x++ )
  fprintf(dst, " %d", f[x] );
}


void printmap( char* msg, mapping f )
{
galois x;
printf("%s\nfct=", msg);
for( x = 0; x < ffsize; x++ )
  printf(" %d", f[x] );
}


int maplevel( mapping g )
{ int x;
  int v = 0, l = 0;
  for( x = 0; x < ffsize; x++ )
          if ( g[x] > v ) v = g[x];
  // v=0, 1 -> level : 1
  while ( (1 << l) <= v ) l++;
  return l;
}

mapping  filemapsparameters( char *fn , int *cpt, int* level )
{
  mapping g;
  char line[1024];
  FILE * src = fopen( fn, "r" );
  if ( ! src ) {
	  perror( "loadparm");
	  exit(1);
  }
  while (! feof (src) )
    {
      line[0] = '\0';
      fgets (line, 1024, src);
      switch (*line)
        {
        case '#':
          break;
        case 'T' :
          if ( *cpt == 0 ) {
		g = strtomap ( line );
		*level = maplevel( g );
	  }
	  *cpt = *cpt + 1;
          break;
        default:;
        }
    }
    fclose( src );
    return g;
}






