#define _GNU_SOURCE         /* See feature_test_macros(7) */
#include <search.h>

#include "agltools.h"
#include "orbit.h"



uchar *table;			//
int64_t countOrbit;
int64_t orbitSize;
int64_t totalSize;

static int
       compare(const void *pa, const void *pb)
       {
	   const object * pA, *pB;
	   pA = pa;
	   pB = pb;

           if ( pA->w  < pB->w )
               return -1;
           if ( pA->w  > pB->w )
               return 1;
           return 0;
       }

/*
static void freenode( void * pa )
{
	object * pA = pa;
	free(  (* (objet**)pa)->s );
	free( (* (objet**)pa)  );
}
*/

void controle( agl s, boole f )
{
boole g = getboole();
shortvec x;
for( x = 0; x < ffsize; x++ )
	g[x] = f[ aglImage(x, s ) ];
for( x = 0; x < ffsize; x++ )
	g[x] ^= f[x];
assert( degree(g) <= formDegree );
free(g);
}

aglGroup findStabilizer(aglFormGroup lda, class X )
{   // fing generator set of w stabilizer
    aglGroup     res = NULL;
    stack   p = NULL;
    aglFormGroup aux;
    form w;
    agl A, I;
 
    int size = 0, orbsize;
    void *root = NULL;
    void *val;
    object *ptr;

    object x;

    w = booletoform(  X->fct );
    x.w = w;
    x.s = getaglidt(0);
    pushObject( x,  &p  );
    size = 1;
    ptr = malloc( sizeof( object) );
    ptr->w  = w;
    ptr->s  = getaglidt(0);

    //phil : initialisation...
    val = tsearch( (void*) ptr, &root, compare);
    orbsize=1;
    ssinit();
    while ( ssOrder() != X->size ) {
	x = popObject( & p  );
	size--;
	aux = lda;
	while (aux != NULL) {
	    ptr = malloc( sizeof( object) );
	    ptr-> w = aglFormImage(x.w, aux->act);
	    ptr-> s = getaglCompose(x.s, aux->per);
	    
	    val = tsearch((void *) ptr, &root, compare);
	    if (val == NULL)
		exit(EXIT_FAILURE);

	    if ((*(object **) val) != ptr) {
		// deja vu
            	I = aglinverse( (* (object**) val)->s );
            	A = getaglCompose( ptr->s , I );
                free(I);
                SchreierSims(A, 0);
		//phil : why ??
		free(ptr);
	        free(A);
	    } else {
		// nouveau
		pushObject( *ptr, & p );
		size++;
		orbsize++;
		//phil : why
		//free(ptr);
	    }

	    aux = aux->next;
	}
    }
    while ( p )
	popObject( &p);

    //tdestroy( &root, freenode );
    while (root != NULL) {
        ptr = *((object **)root);
        tdelete(ptr, &root, compare);
        free(ptr->s);
        free(ptr);
    } 
    res = ssgen();
    ssfree();
    return res;
}



class oldrepresentative(form w, aglFormGroup lda, class K)
{				// compute the transversval of w under the action generated by lda 
    class res = malloc(sizeof(enrclass));
    pile p = NULL;
    form x, y;
    aglFormGroup aux;
    push(w, &p);
    table[w] = 1;
    orbitSize = 1;
    while (p != NULL) {
	x = pop(&p);
	aux = lda;
	while (aux != NULL) {

	    y = aglFormImage(x, aux->act);
	    if (table[y] == 0) {
		push(y, &p);
		table[y] = 1;
		orbitSize++;
	    }
	    aux = aux->next;
	}
    }

    res->fct = getbooleFormsum(K->fct, w);
    res->size = K->size / orbitSize;
    res->stab = NULL;
    return res;
}

uint64_t agldiv( uint64_t s )
{ int val   = ffdimen;
  uint64_t  res = 1;
  int i;
  if ( s == 1 ) 
	  return 0;
  for( i = 0; i < ffdimen; i++ ) {
	  res *=  ( 1 << (ffdimen - i) ) - 1  ;
	  val += i;
  }
  while ( 0 ==  (s & 1)  ) {
	  s /= 2;
	  val--;
  }
  res = res / s;
  printf("patch r=%ld v=%d res=%ld\n", res, val, res << val );
  res <<= val;
  return res;
}

class representative(form w, aglFormGroup lda, class K)
{
// compute the transversval of w under the action generated by lda 
    class res = malloc(sizeof(enrclass));
    form x, y;
    aglFormGroup aux;
    openFormStack();
    pushForm(w);
    table[w] = 1;
    orbitSize = 1;
    while ( ptrStack  > 0 ) {
	x = popForm( );
	aux = lda;
	while (aux != NULL) {

	    y = aglFormImage(x, aux->act);
	    if (table[y] == 0) {
		pushForm( y );
		table[y] = 1;
		orbitSize++;
	    }
	    aux = aux->next;
	}
    }
    closeFormStack();
    res->fct = getbooleFormsum(K->fct, w);
    // patch
    if ( K->size != 0 )
    	res->size = K->size / orbitSize;
    else 
	res->size = agldiv( orbitSize );
    res->stab = NULL;
    return res;
}



int nearorbits(class K, class * E)
{
    
    aglFormGroup lda = aglGroupAction(K);
    class aux = NULL;
    boole fct;
    form w;
    class tmp;
    table = calloc(formSize, sizeof(char));
    countOrbit=0;
	     totalSize=0;
    for (w = 0; w < formSize; w++)
	if (table[w] == 0) {
    	    countOrbit++;
	    tmp = representative(w, lda, K);	// compute the orbit of w
	    totalSize+=orbitSize;
	    fct = getbooleFormsum(K->fct, w);
	    if ( isnearbent(fct) ) 
		    addClass(tmp, &aux);
	    free(fct);
	}
    free(table);
    while (aux) {
	    // patch
	if ( aux->size > 0 )
		aux->stab = findStabilizer(lda, aux);
	else 
		aux->stab = mkaglGroup( ffdimen );
	tmp = aux;
	aux = aux->next;
	addClass(tmp, E);
    }
    aglFormGroupFree(lda);
    return countOrbit;
}


int orbits(class K, class * E)
{
    
    aglFormGroup lda = aglGroupAction(K);
    class aux = NULL;
    form w;
    class tmp;
    table = calloc(formSize, sizeof(char));
    countOrbit=0;
	     totalSize=0;
    for (w = 0; w < formSize; w++)
	if (table[w] == 0) {
    	    countOrbit++;
	    tmp = representative(w, lda, K);	// compute the orbit of w
	    totalSize+=orbitSize;
	    addClass(tmp, &aux);
	}
    free(table);
    while (aux) {
	    // patch
	if ( aux->size > 0 )
		aux->stab = findStabilizer(lda, aux);
	else 
		aux->stab = mkaglGroup( ffdimen );
	tmp = aux;
	aux = aux->next;
	addClass(tmp, E);
    }
    aglFormGroupFree(lda);
    return countOrbit;
}



void orbitOnly(class K, class * E)
{
    
    aglFormGroup lda = aglGroupAction(K);
    class aux = NULL;
    form w;
    class tmp;
    table = calloc(formSize, sizeof(char));
    countOrbit=0;
	     totalSize=0;
    for (w = 0; w < formSize; w++)
	if (table[w] == 0) {
    	    countOrbit++;
	    tmp = representative(w, lda, K);	// compute the orbit of w
	    totalSize+=orbitSize;
	    addClass(tmp, &aux);
	}
    free(table);
    while (aux) {
	aux->stab = NULL;
	tmp = aux;
	aux = aux->next;
	addClass(tmp, E);
    }
    aglFormGroupFree(lda);
}



void saturation(uchar numero, form w, aglFormGroup lda )
{
    form x, y;
    aglFormGroup aux;
    openFormStack();
    pushForm(w);
    table[w] = numero;
    while ( ptrStack  > 0 ) {
	x = popForm( );
	aux = lda;
	while (aux != NULL) {

	    y = aglFormImage(x, aux->act);
	    if (table[y] == 0) {
		pushForm( y );
		table[y] = numero;
	    }
	    aux = aux->next;
	}
    }
    closeFormStack();
}


uchar* orbitableClass(class K )
{

    aglFormGroup lda = aglGroupAction(K);
    form w;
    table = calloc(formSize, sizeof(char));
    countOrbit=0;
    for (w = 0; w < formSize; w++)
        if ( table[w] == 0 ) {
            countOrbit++;
	    assert( countOrbit < 255 );
            saturation( countOrbit, w, lda );    // compute the orbit of w
        }
    aglFormGroupFree(lda);
    return table;
}




