#ifndef ORBITDATA_H
#define ORBITDATA_H

#include "agltools.h"

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "boolean.h"
#include "mapping.h"
#include "basistools.h"
#include "orbitools.h"


typedef struct _b_ {
	basis_t base;
	agl*     route;
        aglVectorGroup ldg;
	aglGroup grp;
	size_t   grpSize;
} orbitRecord ; 


typedef struct {
	boole f;
	int  t, s;
	orbitRecord W[ 8 ];
	size_t   orbSize;
} orbitData;


orbitData initData( boole f, int s, aglGroup G, size_t grpSize );

void freeData( orbitData * res );


vector aglVectorImages( vector f, aglVector S, int dim );
// the image of f by the action S
// to be improved !!!




void aglRightCompose( agl L, const agl R );

void aglLeftCompose( const agl L, agl R );

agl megacheck( boole h, orbitData *data );
int ismember( boole h, orbitData *data );
#endif

