#ifndef ORBITOOLS_H
#define ORBITOOLS_H

#include <stdint.h>
#include <stdio.h>
#include "boolean.h"
#include "agltools.h"
#include "classtools.h"
#include "basistools.h"

extern int verb;

typedef uint32_t rep_t;

typedef vector * aglVector;

#define BITVECTOR( j, w ) (    (   (  ( (vector) 1) << j  ) & w   )    )

typedef struct _aglVectorGroup_ {
	agl per;
	aglVector act;
	struct _aglVectorGroup_ * next;
} enraglVectorGroup, * aglVectorGroup;



void  initVector( int s, int t, int m);
void  closeVector( void );

#define booletovector(f , b ) booleVector( f, b)

vector booleVector(boole f , basis_t *b );


boole vectortoboole( vector w , basis_t *b );
aglVector vectorAction ( agl s, basis_t *b );


aglVector getaglVector(  int dim  ); 


void  aglVectorGroupFree( aglVectorGroup l);
// free the act's and l, keeping per in memory.


aglVectorGroup aglVectorGroupAction( aglGroup S , basis_t *b );
// builds the generators for the action of
// the class K on the vector vector

aglVector boundaryAction(boole f, agl s, basis_t * b);
aglVector sideAction(boole f, agl s, basis_t * b);
aglVectorGroup aglBoundaryGroupAction( boole f, aglGroup g, basis_t *b );

// to do list !

vector aglVectorImage( vector f, aglVector S);
// the image of f by the action S

int orbitClassBasic( aglGroup g, basis_t *b, class *r  );

int orbitBasic(aglGroup S, basis_t *b);

rep_t *orbitRepresentative( aglGroup S, basis_t *b);
size_t orbittree(vector f, aglGroup S, basis_t *b);
agl* orbitFull(aglGroup S, basis_t *b);

aglGroup plainStabilizer(vector f, aglGroup S, basis_t *b, size_t but);
aglGroup routeStabilizer(agl* R, aglVectorGroup ldg, int size, size_t but);
agl minroute(vector f, aglVectorGroup ldg, basis_t *b);
int orbitTrace(aglGroup S, basis_t *b);
size_t numbrowse(int num, vector  w, aglVectorGroup lda  );
size_t browse(vector  w, aglVectorGroup lda  );
void fullbrowse(vector  w, aglVectorGroup lda  );
void  initBrowse( basis_t *b );
agl* transversale(vector f, aglVectorGroup S, basis_t *b);
size_t  minbrowse(vector  *w, vector * cw, aglVectorGroup lda  );
void controle( vector f,  aglVectorGroup ldg, basis_t *b );


agl getaglorbit(vector w, aglGroup S, basis_t *b, int mode);

#endif
