#include "vectorial.h"
#include <ctype.h>


vector * loadvect( FILE * source, int level )
{ vector *V;
	V = calloc( level , sizeof(vector) );
	int j, nb;
        for( j = 0;  j < level ; j++ ) {
                        nb = fread( & V[j], 1 , sizeof(vector), source );
			if ( nb != sizeof(vector) ){
				free( V);
				return NULL;
			}				
                }
	return V;
}

vector * loadvectplus( FILE * source, int level )
{ vector *V;
	V = calloc( level + 1 , sizeof(vector) );
	int j, nb;
        for( j = 0;  j < level ; j++ ) {
                        nb = fread( & V[j], 1 , sizeof(vector), source );
			if ( nb != sizeof(vector) ){
				free( V);
				return NULL;
			}				
                }
	return V;
}

void savevect( FILE * destin, vector* V, int level )
{ 
	int j, nb;
        for( j = 0;  j < level ; j++ ) {
                        nb = fwrite( & V[j], 1 , sizeof(vector), destin );
			assert( nb == 8 );
                }
}
void sort(  vector *sp, int q )
{
	int i, j;
 vector tmp;
        for( i = 0; i < q ; i++)
        for( j = i+1; j < q ; j++)
                if ( sp[i] > sp[j] ) {
                        tmp = sp[i];
                        sp[i] = sp[j];
                        sp[j] = tmp;
                }

}

vector *devsort( vector *F, int level )
{ vector *sp = calloc( 1 << level, sizeof(vector) );
        sp[ 0 ] = 0;
    sp[ 1 ] = F[0];
    int i, j, k;
    for ( k = 1; k < level; k++) {
        for( j = 0; j < (1<<k) ; j++ )
                sp[ j + (1<<k) ] = sp[ j ] ^ F[k];
    }
        
        vector tmp;
	int q = 1 << level;
        for( i = 0; i < q ; i++)
        for( j = i+1; j < q ; j++)
                if ( sp[i] > sp[j] ) {
                        tmp = sp[i];
                        sp[i] = sp[j];
                        sp[j] = tmp;
                }
   return sp;
}


vector *devspace( vector *F, int level )
{ vector *sp = calloc( 1 << level, sizeof(vector) );
        sp[ 0 ] = 0;
    sp[ 1 ] = F[0];
    int j, k;
    for ( k = 1; k < level; k++) {
        for( j = 0; j < (1<<k) ; j++ )
                sp[ j + (1<<k) ] = sp[ j ] ^ F[k];
    }
   return sp;
}

int levelname( char *s )
{ 
	
  while ( *s ) s++;
  while ( *s != '.' ) s--;
  s--;
  return *s - '0';
}

void pvect( FILE *dst, vector *V, aglGroup g, uint64_t size, int n )
{
fprintf(dst , "\nvec=" );
int j;
for( j = 0; j < n ; j++ )
     fprintf( dst, " %ld", V[j] );
paglGroup( dst , g );
fprintf(dst, "\nstabSize=%ld\n", size  );
}

vector* loadvectstab(FILE *src, aglGroup * g, uint64_t  *sz, int n )
//-get the current vectorial
{ vector* res = NULL;
  char line[1024];
  while ( fgets(line, 1024, src)  )
    {
      switch (*line)
        {
        case '#':
          break;
        case 'v' :
          res =  calloc( n, sizeof(vector)  );
	  *g  = NULL;
          char * ptr = & line[0];
	  while (*ptr != '=' ) ptr++;
	  int j;
	  for( j = 0; j < n; j++ ){
		  while ( ! isdigit(*ptr)) ptr++ ;
		  sscanf( ptr, "%ld", & res[j] );
		  while ( isdigit(*ptr)) ptr++ ;
	  }
          break;
	case '[' :
          addgenstr( line, g);
          break;
        case 's' :
          sscanf(line, "stabSize=%ld", sz );
          return res;
          break;
        default:
          ;
        }
    }
    return NULL;
}

