#include "word.h"

int wdlen = 3;

void initwd( int l )
{
	wdlen  = l;
}

static int diswcompare( const void *a,  const void *b)
{
  wdis_t* fa, *fb;
  fa = (wdis_t*) a;
  fb = (wdis_t*) b;
  int i;
  for ( i = 0; i < wdlen && ( fa ->dis[i] ==  fb ->dis[i]) ; i++) ;;;
  if ( i == wdlen ) return 0;   
  if ( fa ->dis[i] < fb ->dis[i]) return -1;
  return +1;
}

static void free_node( void *a )
{
  wdis_t* fa;
  fa = (wdis_t*) a;
  free( fa->dis );
  free( fa );
}

void wfree( void * root )
{
  tdestroy( root, free_node);
}
void wsort( word * w)
{
	int i, j;
	word tmp;
	for( i = 0; i < wdlen ; i++)
	for( j = i+1; j < wdlen ; j++)
		if ( w[i] > w[j] ) {
			tmp = w[i];
			w[i] = w[j];
			w[j] = tmp;
		}
}


wdis_t * getwdistribution( word *t  )
{ wdis_t *res = malloc( sizeof(wdis_t) );
  res->dis  = calloc( wdlen , sizeof( word) ) ;
  int i;
  for( i = 0; i < wdlen; i++)
	  res->dis[i] = t[i];
  res->val  = -1;
  return res;
}



int searchwtable( word *t, void **rootp, int* count )
{
wdis_t *ptr;
const void *ret;
int value;
ptr = getwdistribution(  t );
    ret  = tsearch((void *) ptr, rootp , diswcompare );
    if ( ret == NULL)
        exit(EXIT_FAILURE);
    if ((*(wdis_t **) ret)->dis != ptr->dis ) {
        value = (*(wdis_t**) ret)->val;
        free( ptr->dis );
        free( ptr );
    	//printf("old value -> %d \n", value );
        return value;
    };
    // it's new ! 
    ptr->val = *count;
    *count   = *count + 1;
    value    = ptr->val;
    //printf("\nnew distribution  -> %d \n", value );
    return value;
}



int findwtable( word *t, void **rootp, int* count )
{
wdis_t *ptr;
const void *ret;
int value;
ptr = getwdistribution(  t );
    ret  = tfind((void *) ptr, rootp , diswcompare );
    if ( ret == NULL) {
        free( ptr->dis );
        free( ptr );
	return -1;
    }
    value = (*(wdis_t**) ret)->val;
    return value;
}




